diff -Naur src.pgsql/backend/access/bitmap/bitmappages.c src.bitmap/backend/access/bitmap/bitmappages.c
--- src.pgsql/backend/access/bitmap/bitmappages.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bitmap/backend/access/bitmap/bitmappages.c	2006-09-17 00:09:28.000000000 -0700
@@ -0,0 +1,272 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmappage.c
+ *	  Bitmap index page management code for the bitmap index.
+ *
+ * Copyright (c) 2006, PostgreSQL Global Development Group
+ *
+ *
+ * IDENTIFICATION
+ *	  $PostgreSQL$
+ *-------------------------------------------------------------------------
+ */
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/tupdesc.h"
+#include "access/bitmap.h"
+#include "storage/lmgr.h"
+#include "parser/parse_oper.h"
+#include "miscadmin.h"
+
+/*
+ * _bitmap_getbuf() -- return the buffer for the given block number and
+ * 					   the access method.
+ */
+Buffer
+_bitmap_getbuf(Relation rel, BlockNumber blkno, int access)
+{
+	Buffer buf;
+
+	buf = ReadBuffer(rel, blkno);
+	if (access != BM_NOLOCK)
+		LockBuffer(buf, access);
+
+	return buf;
+}
+
+/*
+ * _bitmap_wrtbuf() -- write a buffer page to disk.
+ *
+ * Release the lock and the pin held on the buffer.
+ */
+void
+_bitmap_wrtbuf(Buffer buf)
+{
+	MarkBufferDirty(buf);
+	UnlockReleaseBuffer(buf);
+}
+
+/*
+ * _bitmap_wrtnorelbuf() -- write a buffer page to disk without still holding
+ *		the pin on this page.
+ */
+void
+_bitmap_wrtnorelbuf(Buffer buf)
+{
+	MarkBufferDirty(buf);
+}
+
+/*
+ * _bitmap_relbuf() -- release the buffer without writing.
+ */
+void
+_bitmap_relbuf(Buffer buf)
+{
+	UnlockReleaseBuffer(buf);
+}
+
+/*
+ * _bitmap_init_lovpage -- initialize a new LOV page.
+ */
+void
+_bitmap_init_lovpage(Relation rel, Buffer buf)
+{
+	Page			page;
+
+	page = (Page) BufferGetPage(buf);
+
+	if(PageIsNew(page))
+		PageInit(page, BufferGetPageSize(buf), 0);
+
+}
+
+/*
+ * _bitmap_init_bitmappage() -- initialize a new page to store the bitmap.
+ *
+ * Note: This function requires an exclusive lock on the metapage.
+ */
+void
+_bitmap_init_bitmappage(Relation rel, Buffer buf)
+{
+	Page			page;
+	BMBitmapOpaque	opaque;
+
+	page = (Page) BufferGetPage(buf);
+
+	if(PageIsNew(page))
+		PageInit(page, BufferGetPageSize(buf), sizeof(BMBitmapOpaqueData));
+
+	/* even though page may not be new, reset all values */
+	opaque = (BMBitmapOpaque) PageGetSpecialPointer(page);
+	opaque->bm_hrl_words_used = 0;
+	opaque->bm_bitmap_next = InvalidBlockNumber;
+	opaque->bm_last_tid_location = 0;
+}
+
+/*
+ * _bitmap_init_buildstate() -- initialize the build state before building
+ *	a bitmap index.
+ */
+void
+_bitmap_init_buildstate(Relation index, BMBuildState *bmstate)
+{
+	uint32		attno;
+	Page		page;
+	BMMetaPage	mp;
+
+	/* initialize the build state */
+	bmstate->bm_metabuf = _bitmap_getbuf(index, BM_METAPAGE, BM_WRITE);
+	bmstate->bm_tupDesc = RelationGetDescr(index);
+
+	bmstate->bm_tidLocsBuffer = (BMTidLocsBuffer*)
+		palloc0(BM_MAX_TIDLOCS_BUFFER_SIZE);
+	bmstate->bm_tidLocsBuffer->bm_max_values = BM_NUM_DISTINCT_VALUES;
+
+	bmstate->bm_num_lov_blocks = 0;
+	bmstate->bm_max_num_lov_blocks = BM_NUM_LOV_BLOCKS;
+	bmstate->bm_lov_blocks = (BlockNumber *)
+		palloc0(bmstate->bm_max_num_lov_blocks * sizeof(BlockNumber));
+
+	page = BufferGetPage(bmstate->bm_metabuf);
+	mp = (BMMetaPage) PageGetContents(page);
+	_bitmap_open_lov_heapandindex(index, mp, &(bmstate->bm_lov_heap),
+								&(bmstate->bm_lov_index), 
+								RowExclusiveLock);
+
+	_bitmap_wrtnorelbuf(bmstate->bm_metabuf);
+	LockBuffer(bmstate->bm_metabuf, BUFFER_LOCK_UNLOCK);
+
+	bmstate->bm_lov_scanKeys =
+		(ScanKey)palloc0(bmstate->bm_tupDesc->natts * sizeof(ScanKeyData));
+
+	for (attno = 0; attno < bmstate->bm_tupDesc->natts; attno++)
+	{
+		RegProcedure	opfuncid;
+		Oid				atttypid;
+
+		atttypid = bmstate->bm_tupDesc->attrs[attno]->atttypid;
+		opfuncid = equality_oper_funcid(atttypid);
+
+		ScanKeyEntryInitialize(&(bmstate->bm_lov_scanKeys[attno]), SK_ISNULL, 
+							   attno + 1, BTEqualStrategyNumber, InvalidOid, 
+							   opfuncid, 0);
+	}
+
+	bmstate->bm_lov_scanDesc = index_beginscan(bmstate->bm_lov_heap,
+						 bmstate->bm_lov_index, SnapshotAny, 
+						 bmstate->bm_tupDesc->natts,
+						 bmstate->bm_lov_scanKeys);
+
+    /*
+     * We need to log index creation in WAL iff WAL archiving is enabled AND
+     * it's not a temp index.
+     */
+    bmstate->use_wal = XLogArchivingActive() && !index->rd_istemp;
+
+}
+
+/*
+ * _bitmap_cleanup_buildstate() -- clean up the build state after
+ *	inserting all rows in the heap into the bitmap index.
+ */
+void
+_bitmap_cleanup_buildstate(Relation index, BMBuildState *bmstate)
+{
+	/* write out remaining tids in bmstate->bm_tidLicsBuffer */
+	BMTidLocsBuffer*	tidLocsBuffer = bmstate->bm_tidLocsBuffer;
+	_bitmap_write_alltids(index, bmstate->bm_metabuf, tidLocsBuffer,
+						  BM_MAX_TIDLOCS/tidLocsBuffer->bm_max_values - 1,
+						  bmstate->bm_lov_blocks, bmstate->use_wal);
+
+	index_endscan(bmstate->bm_lov_scanDesc);
+	ReleaseBuffer(bmstate->bm_metabuf);
+	_bitmap_close_lov_heapandindex(bmstate->bm_lov_heap,bmstate->bm_lov_index,
+						 		   RowExclusiveLock);
+	pfree(bmstate->bm_tidLocsBuffer);
+	pfree(bmstate->bm_lov_blocks);
+	pfree(bmstate->bm_lov_scanKeys);
+}
+
+/*
+ * _bitmap_init() -- initialize the bitmap index.
+ *
+ * Create the meta page, a new heap which stores the distinct values for
+ * the attributes to be indexed, a btree index on this new heap for searching
+ * those distinct values, and the first LOV page.
+ */
+void
+_bitmap_init(Relation rel, bool use_wal)
+{
+	BMMetaPage		metapage;
+	Buffer			metabuf;
+	Page			page;
+	Buffer			buf;
+	BMLOVItem 		lovItem;
+	OffsetNumber	newOffset;
+	Page			currLovPage;
+	OffsetNumber	o;
+  
+	/* sanity check */
+	if (RelationGetNumberOfBlocks(rel) != 0)
+		ereport(ERROR,
+				(errcode(ERRCODE_INDEX_CORRUPTED),
+				errmsg("cannot initialize non-empty bitmap index \"%s\"",
+				RelationGetRelationName(rel))));
+
+	/* create the metapage */
+	metabuf = _bitmap_getbuf(rel, P_NEW, BM_WRITE);
+	page = BufferGetPage(metabuf);
+	Assert(PageIsNew(page));
+
+	/* initialize the metapage */
+	PageInit(page, BufferGetPageSize(metabuf), 0);
+	metapage = (BMMetaPage) PageGetContents(page);
+	metapage->bm_num_tuples = 0;
+	metapage->bm_need_rebuilt = false;
+
+	if(use_wal)
+		_bitmap_log_newpage(rel, XLOG_BITMAP_INSERT_NEWMETA, metabuf);
+	
+	/* initialize the LOV metadata */
+	_bitmap_create_lov_heapandindex(rel, &(metapage->bm_lov_heapId),
+									&(metapage->bm_lov_indexId));
+
+	/* allocate the first LOV page. */
+	buf = _bitmap_getbuf(rel, P_NEW, BM_WRITE);
+	_bitmap_init_lovpage(rel, buf);
+
+	if(use_wal)
+		_bitmap_log_newpage(rel, XLOG_BITMAP_INSERT_NEWLOV, buf);
+
+	currLovPage = BufferGetPage(buf);
+
+	/* set the first item to support NULL value */
+	lovItem = _bitmap_formitem(0);
+	newOffset = OffsetNumberNext(PageGetMaxOffsetNumber(currLovPage));
+
+	/*
+	 * XXX: perhaps this could be a special page, with more efficient storage
+	 * after all, we have fixed size data
+	 */
+	o = PageAddItem(currLovPage, (Item)lovItem, sizeof(BMLOVItemData),
+                    newOffset, LP_USED);
+
+	if (o == InvalidOffsetNumber)
+		ereport(ERROR,
+				(errcode(ERRCODE_INTERNAL_ERROR),
+				 errmsg("failed to add LOV item to \"%s\"",
+				 RelationGetRelationName(rel))));
+
+	metapage->bm_lov_lastpage = BufferGetBlockNumber(buf);
+	if(use_wal)
+		_bitmap_log_lovitem(rel, buf, true, newOffset, lovItem);
+	pfree(lovItem);
+
+	_bitmap_wrtbuf(buf);
+
+	if(use_wal)
+		_bitmap_log_metapage(rel, page);
+	/* write the metapage */
+	_bitmap_wrtbuf(metabuf);
+}
diff -Naur src.pgsql/backend/access/bitmap/bitmapsearch.c src.bitmap/backend/access/bitmap/bitmapsearch.c
--- src.pgsql/backend/access/bitmap/bitmapsearch.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bitmap/backend/access/bitmap/bitmapsearch.c	2006-09-17 00:09:28.000000000 -0700
@@ -0,0 +1,554 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmapsearch.c
+ *	  Search routines for on-disk bitmap index access method.
+ *
+ *
+ * Copyright (c) 2006, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *	  $PostgreSQL$
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/tupdesc.h"
+#include "access/bitmap.h"
+#include "storage/lmgr.h"
+#include "parser/parse_oper.h"
+
+static void next_batch_words(IndexScanDesc scan);
+static void read_words(Relation rel, Buffer lovBuffer, 
+					   OffsetNumber lovOffset, BlockNumber *nextBlockNoP,
+							  BM_HRL_WORD *headerWords, BM_HRL_WORD *words,
+							  uint32 *numOfWordsP, bool *readLastWords);
+static void init_scanpos(IndexScanDesc scan, BMBitmapScanPosition bmScanPos,
+					 BlockNumber lovBlock, OffsetNumber lovOffset);
+
+/*
+ * _bitmap_first() -- find the first tuple that satisfies a given scan.
+ */
+bool
+_bitmap_first(IndexScanDesc scan, ScanDirection dir)
+{
+	_bitmap_findbitmaps(scan, dir);
+	return _bitmap_next(scan, dir);
+}
+
+/*
+ * _bitmap_next() -- return the next tuple that satisfies a given scan.
+ */
+bool
+_bitmap_next(IndexScanDesc scan, ScanDirection dir)
+{
+	BMScanOpaque	so;
+	BMScanPosition	scanPos;
+	uint64			nextTid;
+
+	so = (BMScanOpaque) scan->opaque;
+	scanPos = so->bm_currPos;
+
+	if (scanPos->bm_done)
+		return false;
+
+	for (;;)
+	{
+		/*
+		 * If there are no more words left from the previous scan, we
+		 * try to compute the next batch of words.
+		 */
+		if (scanPos->bm_batchWords->numOfWords == 0 &&
+			scanPos->bm_result.nextTidLoc >= scanPos->bm_result.numOfTids)
+		{
+			_bitmap_reset_batchwords(scanPos->bm_batchWords);
+			scanPos->bm_batchWords->firstTid = scanPos->bm_result.nextTid;
+
+			next_batch_words(scan);
+
+			_bitmap_begin_iterate(scanPos->bm_batchWords, &(scanPos->bm_result));
+		}
+
+		/* If we can not find more words, then this scan is over. */
+		if (scanPos->bm_batchWords->numOfWords == 0 &&
+			scanPos->bm_result.nextTidLoc >= scanPos->bm_result.numOfTids)
+			return false;
+
+		nextTid = _bitmap_findnexttid(scanPos->bm_batchWords,
+									  &(scanPos->bm_result));
+		if (nextTid == 0)
+			continue;
+		else
+			break;
+	}
+
+	Assert((nextTid % BM_MAX_HTUP_PER_PAGE) + 1 > 0);
+
+	ItemPointerSet(&(scan->xs_ctup.t_self), BM_INT_GET_BLOCKNO(nextTid),
+				   BM_INT_GET_OFFSET(nextTid));
+	scan->currentItemData = scan->xs_ctup.t_self;
+
+	return true;
+}
+
+/*
+ * _bitmap_firstbatchwords() -- find the first batch of bitmap words
+ *  in a bitmap vector for a given scan.
+ */
+bool
+_bitmap_firstbatchwords(IndexScanDesc scan,
+						ScanDirection dir)
+{
+	_bitmap_findbitmaps(scan, dir);
+
+	return _bitmap_nextbatchwords(scan, dir);
+}
+
+/*
+ * _bitmap_nextbatchwords() -- find the next batch of bitmap words
+ *  in a bitmap vector for a given scan.
+ */
+bool
+_bitmap_nextbatchwords(IndexScanDesc scan,
+					   ScanDirection dir)
+{
+	BMScanOpaque	so;
+
+	so = (BMScanOpaque) scan->opaque;
+
+	/* check if this scan if over */
+	if (so->bm_currPos->bm_done)
+		return false;
+
+	/*
+	 * If there are some leftover words from the previous scan, simply
+	 * return them.
+	 */
+	if (so->bm_currPos->bm_batchWords->numOfWords > 0)
+		return true;
+
+	next_batch_words(scan);
+
+	return true;
+}
+
+/*
+ * next_batch_words() -- compute the next batch of bitmap words
+ * 	from a given scan position.
+ */
+static void
+next_batch_words(IndexScanDesc scan)
+{
+	BMScanPosition			scanPos;
+	BMBitmapScanPosition	bmScanPos;
+	int						i;
+	BMBatchWords		  **batches;
+	int						numBatches;
+
+	scanPos = ((BMScanOpaque) scan->opaque)->bm_currPos;
+	bmScanPos = scanPos->bm_bitmapScanPos;
+
+	batches = (BMBatchWords **)
+		palloc0(scanPos->bm_numBitmapVectors * sizeof(BMBatchWords *));
+
+	numBatches = 0;
+	/*
+	 * Obtains the next batch of words for each bitmap vector.
+	 * Ignores those bitmap vectors that contain no new words.
+	 */
+	for (i = 0; i < scanPos->bm_numBitmapVectors; i++)
+	{
+		BMBatchWords	*batchWords;
+		batchWords = bmScanPos[i].bm_batchWords;
+
+		/*
+		 * If there are no words left from previous scan, read the next
+		 * batch of words.
+		 */
+		if (bmScanPos[i].bm_batchWords->numOfWords == 0 &&
+			!(bmScanPos[i].bm_readLastWords))
+		{
+
+			_bitmap_reset_batchwords(batchWords);
+			read_words(scan->indexRelation,
+							  bmScanPos[i].bm_lovBuffer,
+							  bmScanPos[i].bm_lovOffset,
+							  &(bmScanPos[i].bm_nextBlockNo),
+							  batchWords->bitmapHeaderWords,
+							  batchWords->bitmapContentWords,
+						  	  &(batchWords->numOfWords),
+							  &(bmScanPos[i].bm_readLastWords));
+		}
+
+		if (bmScanPos[i].bm_batchWords->numOfWords > 0)
+		{
+			batches[numBatches] = batchWords;
+			numBatches++;
+		}
+	}
+
+	/*
+	 * We handle the case where only one bitmap vector contributes to
+	 * the scan separately with other cases. This is because 
+	 * bmScanPos->bm_batchWords and scanPos->bm_batchWords
+	 * are the same.
+	 */
+	if (scanPos->bm_numBitmapVectors == 1)
+	{
+		if (bmScanPos->bm_batchWords->numOfWords == 0)
+			scanPos->bm_done = true;
+		pfree(batches);
+		scanPos->bm_batchWords = scanPos->bm_bitmapScanPos->bm_batchWords;
+
+		return;
+	}
+
+	/*
+	 * At least two bitmap vectors contribute to this scan, we
+	 * ORed these bitmap vectors.
+	 */
+	if (numBatches == 0)
+	{
+		scanPos->bm_done = true;
+		pfree(batches);
+		return;
+	}
+
+	_bitmap_union(batches, numBatches, scanPos->bm_batchWords);
+	pfree(batches);
+}
+
+/*
+ * read_words() -- read one-block of bitmap words from
+ *	the bitmap page.
+ *
+ * If nextBlockNo is an invalid block number, then the two last words
+ * are stored in lovItem. Otherwise, read words from nextBlockNo.
+ */
+static void
+read_words(Relation rel, Buffer lovBuffer, OffsetNumber lovOffset,
+				  BlockNumber *nextBlockNoP, BM_HRL_WORD *headerWords, 
+				  BM_HRL_WORD *words, uint32 *numOfWordsP, bool *readLastWords)
+{
+	if (BlockNumberIsValid(*nextBlockNoP))
+	{
+		Buffer bitmapBuffer = _bitmap_getbuf(rel, *nextBlockNoP, BM_READ);
+
+		Page			bitmapPage;
+		BMBitmap		bitmap;
+		BMBitmapOpaque	bo;
+
+		bitmapPage = BufferGetPage(bitmapBuffer);
+
+		bitmap = (BMBitmap) PageGetContents(bitmapPage);
+		bo = (BMBitmapOpaque)PageGetSpecialPointer(bitmapPage);
+
+		*numOfWordsP = bo->bm_hrl_words_used;
+		memcpy(headerWords, bitmap->bm_headerWords,
+				BM_MAX_NUM_OF_HEADER_WORDS * sizeof(BM_HRL_WORD));
+		memcpy(words, bitmap->bm_contentWords, 
+				sizeof(BM_HRL_WORD) * *numOfWordsP);
+
+		*nextBlockNoP = bo->bm_bitmap_next;
+
+		_bitmap_relbuf(bitmapBuffer);
+
+		*readLastWords = false;
+
+		/*
+		 * If this is the last bitmap page and the total number of words
+		 * in this page is less than or equal to
+		 * BM_NUM_OF_HRL_WORDS_PER_PAGE - 2, we read the last two words
+		 * and append them into 'headerWords' and 'words'.
+		 */
+		/* XXX: this is messy, lets hide it in a define */
+		if ((!BlockNumberIsValid(*nextBlockNoP)) &&
+			(*numOfWordsP <= BM_NUM_OF_HRL_WORDS_PER_PAGE - 2))
+		{
+			BM_HRL_WORD	lastWords[2];
+			BM_HRL_WORD	lastHeaderWords;
+			BM_HRL_WORD tmp;
+			uint32		numWords;
+			int			offs;
+
+			read_words(rel, lovBuffer, lovOffset, nextBlockNoP,
+							  &lastHeaderWords, lastWords, &numWords,
+							  readLastWords);
+
+			Assert(numWords == 2);
+
+			memcpy(words + *numOfWordsP, lastWords, 2 * sizeof(BM_HRL_WORD));
+			offs = *numOfWordsP / BM_HRL_WORD_SIZE;
+
+			tmp = lastHeaderWords >> *numOfWordsP % BM_HRL_WORD_SIZE;
+			headerWords[offs] |= tmp;
+
+			if (*numOfWordsP % BM_HRL_WORD_SIZE == BM_HRL_WORD_SIZE - 1)
+			{
+				offs = (*numOfWordsP + 1)/BM_HRL_WORD_SIZE;
+				headerWords[offs] |= lastHeaderWords << 1;
+			}
+			*numOfWordsP += 2;
+		}
+	}
+	else
+	{
+		BMLOVItem	lovItem;
+		Page		lovPage;
+
+		LockBuffer(lovBuffer, BM_READ);
+
+		lovPage = BufferGetPage(lovBuffer);
+		lovItem = (BMLOVItem) PageGetItem(lovPage, 
+										  PageGetItemId(lovPage, lovOffset));
+
+		if (lovItem->bm_last_compword != LITERAL_ALL_ONE)
+		{
+			*numOfWordsP = 2;
+			headerWords[0] = (((BM_HRL_WORD)lovItem->bm_last_two_headerbits) <<
+							  (BM_HRL_WORD_SIZE-2));
+			words[0] = lovItem->bm_last_compword;
+			words[1] = lovItem->bm_last_word;
+		}
+		else
+		{
+			*numOfWordsP = 1;
+			headerWords[0] = (((BM_HRL_WORD)lovItem->bm_last_two_headerbits) <<
+							  (BM_HRL_WORD_SIZE-1));
+			words[0] = lovItem->bm_last_word;
+		}
+
+		LockBuffer(lovBuffer, BUFFER_LOCK_UNLOCK);
+		*readLastWords = true;
+	}
+}
+
+/*
+ * _bitmap_findbitmaps() -- find the bitmap vectors that satisfy the
+ * index predicate.
+ */
+void
+_bitmap_findbitmaps(IndexScanDesc scan,
+					ScanDirection dir)
+{
+	BMScanOpaque			so;
+	BMScanPosition			scanPos;
+	Buffer					metabuf;
+	BMMetaPage				metapage;
+	BlockNumber				lovBlock;
+	OffsetNumber			lovOffset;
+	BlockNumber*			lovBlocks;
+	OffsetNumber*			lovOffsets;
+	bool					blockNull, offsetNull;
+	bool					isnull = true;
+	int						vectorNo, keyNo;
+	int						loopNo;
+
+	so = (BMScanOpaque) scan->opaque;
+
+	/* allocate space and initialize values for so->bm_currPos */
+	if(so->bm_currPos == NULL)
+		so->bm_currPos = (BMScanPosition) palloc0(sizeof(BMScanPositionData));
+
+	scanPos = so->bm_currPos;
+	scanPos->bm_numBitmapVectors = 0;
+	scanPos->bm_done = false;
+	scanPos->bm_startBitmapVectorNo = 0;
+	MemSet(&(scanPos->bm_result), 0, sizeof(BMIterateResult));
+	scanPos->isstream = false;	/* we may overrightt his later */
+
+	metabuf = _bitmap_getbuf(scan->indexRelation, BM_METAPAGE, BM_READ);
+	metapage = (BMMetaPage)PageGetContents(BufferGetPage(metabuf));
+
+	for (keyNo = 0; keyNo < scan->numberOfKeys; keyNo++)
+	{
+		if (!((scan->keyData[keyNo]).sk_flags & SK_ISNULL))
+			isnull = false;
+	}
+
+	/*
+	 * If the values for these keys are all NULL, the bitmap vector
+	 * is the first LOV item in the LOV pages.
+	 */
+	if (isnull)
+	{
+		lovBlock = BM_LOV_STARTPAGE;
+		lovOffset = 1;
+
+		scanPos->bm_bitmapScanPos = (BMBitmapScanPosition)
+			palloc0(sizeof(BMBitmapScanPositionData));
+
+		init_scanpos(scan, scanPos->bm_bitmapScanPos,
+							 lovBlock, lovOffset);
+		scanPos->bm_numBitmapVectors = 1;
+
+	}
+	else
+	{
+		Relation		lovHeap, lovIndex;
+		TupleDesc		indexTupDesc;
+		ScanKey			scanKeys;
+		IndexScanDesc	scanDesc;
+
+		_bitmap_open_lov_heapandindex(scan->indexRelation, metapage, 
+				 &lovHeap, &lovIndex, AccessShareLock);
+
+		indexTupDesc = RelationGetDescr(lovIndex);
+
+		Assert(scan->numberOfKeys <= indexTupDesc->natts);
+
+		scanKeys = palloc0(scan->numberOfKeys * sizeof(ScanKeyData));
+		/* XXX: simplify this */
+		for (keyNo = 0; keyNo < scan->numberOfKeys; keyNo++)
+		{
+			RegProcedure	opfuncid;
+			ScanKey	scanKey = (ScanKey)(((char *)scanKeys) + 
+										 keyNo * sizeof(ScanKeyData));
+
+			opfuncid =
+				equality_oper_funcid(indexTupDesc->attrs[keyNo]->atttypid);
+			ScanKeyEntryInitialize(scanKey, SK_ISNULL, keyNo + 1, 
+								   BTEqualStrategyNumber, InvalidOid, 
+								   opfuncid, 0);
+
+			if ((scan->keyData[keyNo]).sk_flags & SK_ISNULL)
+			{
+				scanKey->sk_flags = SK_ISNULL;
+				scanKey->sk_argument = scan->keyData[keyNo].sk_argument;
+			}
+			else
+			{
+				scanKey->sk_flags = 0;
+				scanKey->sk_argument = scan->keyData[keyNo].sk_argument;
+			}
+		}
+
+		/* XXX: is SnapshotAny really the right choice? */
+
+		scanDesc = index_beginscan(lovHeap, lovIndex, SnapshotAny,
+								   scan->numberOfKeys, scanKeys);
+
+#define	BM_NUM_BITMAPS 100
+		lovBlocks = (BlockNumber *)palloc0(BM_NUM_BITMAPS * sizeof(BlockNumber));
+		lovOffsets = (OffsetNumber*)palloc0(BM_NUM_BITMAPS * sizeof(OffsetNumber));
+		loopNo = 1;
+
+		/*
+		 * finds all lov items for this scan through lovHeap and lovIndex.
+		 */
+		while (true)
+		{
+
+			bool res = _bitmap_findvalue(lovHeap, lovIndex, scanKeys, scanDesc,
+							  	         &lovBlock, &blockNull, &lovOffset, 
+										 &offsetNull);
+
+			if(!res)
+				break;
+
+			/*
+			 * If we don't have enough space in lovBlocks and lovOffsets,
+			 * we allocate a bigger space with double of the previous
+			 * size.
+			 */
+			if (scanPos->bm_numBitmapVectors / (loopNo * BM_NUM_BITMAPS) > 0)
+			{
+				/* XXX: arg, use a List or something */
+				BlockNumber *newLovBlocks = (BlockNumber*)
+					palloc0((loopNo+1) * BM_NUM_BITMAPS * sizeof(BlockNumber));
+				OffsetNumber *newLovOffsets = (OffsetNumber*)
+					palloc0((loopNo+1) * BM_NUM_BITMAPS * sizeof(OffsetNumber));
+
+				memcpy(newLovBlocks, lovBlocks,
+					   loopNo * BM_NUM_BITMAPS * sizeof(BlockNumber));
+				memcpy(newLovOffsets, lovOffsets,
+					   loopNo * BM_NUM_BITMAPS * sizeof(OffsetNumber));
+
+				pfree(lovBlocks);
+				pfree(lovOffsets);
+
+				loopNo++;
+
+				lovBlocks = newLovBlocks;
+				lovOffsets = newLovOffsets;
+			}
+			
+			lovBlocks[scanPos->bm_numBitmapVectors] = lovBlock;
+			lovOffsets[scanPos->bm_numBitmapVectors] = lovOffset;
+			scanPos->bm_numBitmapVectors++;
+		}
+
+		scanPos->bm_bitmapScanPos = (BMBitmapScanPosition)
+			palloc0(sizeof(BMBitmapScanPositionData) *
+					scanPos->bm_numBitmapVectors);
+		for (vectorNo=0; vectorNo<scanPos->bm_numBitmapVectors; vectorNo++)
+		{
+			BMBitmapScanPosition bmScanPos =
+				&(scanPos->bm_bitmapScanPos[vectorNo]);
+			init_scanpos(scan, bmScanPos, lovBlocks[vectorNo], 
+						 lovOffsets[vectorNo]);
+		}
+
+		pfree(lovBlocks);
+		pfree(lovOffsets);
+
+		index_endscan(scanDesc);
+		_bitmap_close_lov_heapandindex(lovHeap, lovIndex, AccessShareLock);
+		pfree(scanKeys);
+	}
+
+	_bitmap_relbuf(metabuf);
+
+	if (scanPos->bm_numBitmapVectors == 0)
+	{
+		scanPos->bm_done = true;
+		return;
+	}
+
+	/*
+	 * Since there is only one related bitmap vector, we share
+	 * the result OnDiskBitmapWords with that of this bitmap vector.
+	 */
+	if (scanPos->bm_numBitmapVectors == 1)
+		scanPos->bm_batchWords = scanPos->bm_bitmapScanPos->bm_batchWords;
+	else
+	{
+		scanPos->bm_batchWords = (BMBatchWords *) palloc0(sizeof(BMBatchWords));
+		_bitmap_init_batchwords(scanPos->bm_batchWords,
+								BM_NUM_OF_HRL_WORDS_PER_PAGE,
+								CurrentMemoryContext);	
+	}
+}
+
+/*
+ * init_scanpos() -- initialize a BMScanPosition for a given
+ *	bitmap vector.
+ */
+static void
+init_scanpos(IndexScanDesc scan,
+					 BMBitmapScanPosition bmScanPos,
+					 BlockNumber lovBlock,
+					 OffsetNumber lovOffset)
+{
+	Page 					lovPage;
+	BMLOVItem				lovItem;
+
+	bmScanPos->bm_lovOffset = lovOffset;
+	bmScanPos->bm_lovBuffer = _bitmap_getbuf(scan->indexRelation, lovBlock, 
+										     BM_READ);
+
+	lovPage	= BufferGetPage(bmScanPos->bm_lovBuffer);
+	lovItem = (BMLOVItem) 
+		PageGetItem(lovPage, PageGetItemId (lovPage, bmScanPos->bm_lovOffset));
+			
+	bmScanPos->bm_nextBlockNo = lovItem->bm_lov_head;
+	bmScanPos->bm_readLastWords = false;
+	bmScanPos->bm_batchWords = (BMBatchWords *) palloc0(sizeof(BMBatchWords));
+	_bitmap_init_batchwords(bmScanPos->bm_batchWords,
+							BM_NUM_OF_HRL_WORDS_PER_PAGE,
+							CurrentMemoryContext);	
+
+	LockBuffer(bmScanPos->bm_lovBuffer, BUFFER_LOCK_UNLOCK);
+}
